import deprecate from 'util-deprecate';
import chalk from 'chalk';
import semver, { satisfies, gt, validRange, minVersion } from 'semver';
import { sync, command } from 'execa';
import path2, { dirname, join } from 'path';
import fs2, { existsSync, readFileSync as readFileSync$1 } from 'fs';
import dedent from 'ts-dedent';
import fse, { readFileSync, readFile, writeFile, createWriteStream, move, remove, pathExistsSync } from 'fs-extra';
import 'strip-json-comments';
import findUp, { sync as sync$1 } from 'find-up';
import downloadTarball from '@ndelangen/get-tarball';
import getNpmTarballUrl from 'get-npm-tarball-url';
import * as tempy from 'tempy';
import tempy__default from 'tempy';
import { rendererPackages } from '@storybook/core-common';
import { sync as sync$2 } from 'cross-spawn';
import sort from 'semver/functions/sort';
import { platform } from 'os';
import { ZipOpenFS, VirtualFS, PosixFS } from '@yarnpkg/fslib';
import { getLibzipSync } from '@yarnpkg/libzip';

var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __require = /* @__PURE__ */ ((x) => typeof require !== "undefined" ? require : typeof Proxy !== "undefined" ? new Proxy(x, {
  get: (a, b) => (typeof require !== "undefined" ? require : a)[b]
}) : x)(function(x) {
  if (typeof require !== "undefined")
    return require.apply(this, arguments);
  throw Error('Dynamic require of "' + x + '" is not supported');
});
var __commonJS = (cb, mod) => function __require2() {
  return mod || (0, cb[__getOwnPropNames(cb)[0]])((mod = { exports: {} }).exports, mod), mod.exports;
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));

// src/versions.ts
var versions_default = {
  "@storybook/addon-a11y": "7.2.0",
  "@storybook/addon-actions": "7.2.0",
  "@storybook/addon-backgrounds": "7.2.0",
  "@storybook/addon-controls": "7.2.0",
  "@storybook/addon-docs": "7.2.0",
  "@storybook/addon-essentials": "7.2.0",
  "@storybook/addon-highlight": "7.2.0",
  "@storybook/addon-interactions": "7.2.0",
  "@storybook/addon-jest": "7.2.0",
  "@storybook/addon-links": "7.2.0",
  "@storybook/addon-mdx-gfm": "7.2.0",
  "@storybook/addon-measure": "7.2.0",
  "@storybook/addon-outline": "7.2.0",
  "@storybook/addon-themes": "7.2.0",
  "@storybook/addon-storyshots": "7.2.0",
  "@storybook/addon-storyshots-puppeteer": "7.2.0",
  "@storybook/addon-storysource": "7.2.0",
  "@storybook/addon-toolbars": "7.2.0",
  "@storybook/addon-viewport": "7.2.0",
  "@storybook/addons": "7.2.0",
  "@storybook/angular": "7.2.0",
  "@storybook/api": "7.2.0",
  "@storybook/blocks": "7.2.0",
  "@storybook/builder-manager": "7.2.0",
  "@storybook/builder-vite": "7.2.0",
  "@storybook/builder-webpack5": "7.2.0",
  "@storybook/channel-postmessage": "7.2.0",
  "@storybook/channel-websocket": "7.2.0",
  "@storybook/channels": "7.2.0",
  "@storybook/cli": "7.2.0",
  "@storybook/client-api": "7.2.0",
  "@storybook/client-logger": "7.2.0",
  "@storybook/codemod": "7.2.0",
  "@storybook/components": "7.2.0",
  "@storybook/core-client": "7.2.0",
  "@storybook/core-common": "7.2.0",
  "@storybook/core-events": "7.2.0",
  "@storybook/core-server": "7.2.0",
  "@storybook/core-webpack": "7.2.0",
  "@storybook/csf-plugin": "7.2.0",
  "@storybook/csf-tools": "7.2.0",
  "@storybook/docs-tools": "7.2.0",
  "@storybook/ember": "7.2.0",
  "@storybook/html": "7.2.0",
  "@storybook/html-vite": "7.2.0",
  "@storybook/html-webpack5": "7.2.0",
  "@storybook/instrumenter": "7.2.0",
  "@storybook/manager": "7.2.0",
  "@storybook/manager-api": "7.2.0",
  "@storybook/nextjs": "7.2.0",
  "@storybook/node-logger": "7.2.0",
  "@storybook/postinstall": "7.2.0",
  "@storybook/preact": "7.2.0",
  "@storybook/preact-vite": "7.2.0",
  "@storybook/preact-webpack5": "7.2.0",
  "@storybook/preset-create-react-app": "7.2.0",
  "@storybook/preset-html-webpack": "7.2.0",
  "@storybook/preset-preact-webpack": "7.2.0",
  "@storybook/preset-react-webpack": "7.2.0",
  "@storybook/preset-server-webpack": "7.2.0",
  "@storybook/preset-svelte-webpack": "7.2.0",
  "@storybook/preset-vue-webpack": "7.2.0",
  "@storybook/preset-vue3-webpack": "7.2.0",
  "@storybook/preset-web-components-webpack": "7.2.0",
  "@storybook/preview": "7.2.0",
  "@storybook/preview-api": "7.2.0",
  "@storybook/preview-web": "7.2.0",
  "@storybook/react": "7.2.0",
  "@storybook/react-dom-shim": "7.2.0",
  "@storybook/react-vite": "7.2.0",
  "@storybook/react-webpack5": "7.2.0",
  "@storybook/router": "7.2.0",
  "@storybook/server": "7.2.0",
  "@storybook/server-webpack5": "7.2.0",
  "@storybook/source-loader": "7.2.0",
  "@storybook/store": "7.2.0",
  "@storybook/svelte": "7.2.0",
  "@storybook/svelte-vite": "7.2.0",
  "@storybook/svelte-webpack5": "7.2.0",
  "@storybook/sveltekit": "7.2.0",
  "@storybook/telemetry": "7.2.0",
  "@storybook/theming": "7.2.0",
  "@storybook/types": "7.2.0",
  "@storybook/vue": "7.2.0",
  "@storybook/vue-vite": "7.2.0",
  "@storybook/vue-webpack5": "7.2.0",
  "@storybook/vue3": "7.2.0",
  "@storybook/vue3-vite": "7.2.0",
  "@storybook/vue3-webpack5": "7.2.0",
  "@storybook/web-components": "7.2.0",
  "@storybook/web-components-vite": "7.2.0",
  "@storybook/web-components-webpack5": "7.2.0",
  sb: "7.2.0",
  storybook: "7.2.0"
};
var useNpmWarning = deprecate(
  () => {
  },
  `\`--use-npm\` is deprecated and will be removed in Storybook 8.0. 
Please use the \`--package-manager=npm\` option instead.
Read more at https://github.com/storybookjs/storybook/blob/next/MIGRATION.md#cli-option---use-npm-deprecated`
);
function ltMajor(versionRange, major) {
  return validRange(versionRange) && minVersion(versionRange).major < major;
}
function gtMajor(versionRange, major) {
  return validRange(versionRange) && minVersion(versionRange).major > major;
}
function eqMajor(versionRange, major) {
  return validRange(versionRange) && minVersion(versionRange).major === major;
}
var externalFrameworks = [
  { name: "qwik", packageName: "storybook-framework-qwik" },
  { name: "solid", frameworks: ["storybook-solidjs-vite"], renderer: "storybook-solidjs" },
  { name: "nuxt", packageName: "@storybook-vue/nuxt" }
];
var ProjectType = /* @__PURE__ */ ((ProjectType2) => {
  ProjectType2["UNDETECTED"] = "UNDETECTED";
  ProjectType2["UNSUPPORTED"] = "UNSUPPORTED";
  ProjectType2["REACT"] = "REACT";
  ProjectType2["REACT_SCRIPTS"] = "REACT_SCRIPTS";
  ProjectType2["REACT_NATIVE"] = "REACT_NATIVE";
  ProjectType2["REACT_PROJECT"] = "REACT_PROJECT";
  ProjectType2["WEBPACK_REACT"] = "WEBPACK_REACT";
  ProjectType2["NEXTJS"] = "NEXTJS";
  ProjectType2["VUE"] = "VUE";
  ProjectType2["VUE3"] = "VUE3";
  ProjectType2["SFC_VUE"] = "SFC_VUE";
  ProjectType2["ANGULAR"] = "ANGULAR";
  ProjectType2["EMBER"] = "EMBER";
  ProjectType2["WEB_COMPONENTS"] = "WEB_COMPONENTS";
  ProjectType2["HTML"] = "HTML";
  ProjectType2["QWIK"] = "QWIK";
  ProjectType2["PREACT"] = "PREACT";
  ProjectType2["SVELTE"] = "SVELTE";
  ProjectType2["SVELTEKIT"] = "SVELTEKIT";
  ProjectType2["SERVER"] = "SERVER";
  ProjectType2["NX"] = "NX";
  ProjectType2["SOLID"] = "SOLID";
  ProjectType2["NUXT"] = "NUXT";
  return ProjectType2;
})(ProjectType || {});
var supportedTemplates = [
  {
    preset: "NUXT" /* NUXT */,
    dependencies: ["nuxt"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    preset: "SFC_VUE" /* SFC_VUE */,
    dependencies: {
      "vue-loader": (versionRange) => ltMajor(versionRange, 16),
      vuetify: (versionRange) => ltMajor(versionRange, 3)
    },
    matcherFunction: ({ dependencies }) => {
      return dependencies.some(Boolean);
    }
  },
  {
    preset: "VUE" /* VUE */,
    // This Vue template only works with Vue or Nuxt under v3
    dependencies: {
      vue: (versionRange) => ltMajor(versionRange, 3),
      nuxt: (versionRange) => ltMajor(versionRange, 3)
    },
    matcherFunction: ({ dependencies }) => {
      return dependencies.some(Boolean);
    }
  },
  {
    preset: "VUE3" /* VUE3 */,
    dependencies: {
      // This Vue template works with Vue 3
      vue: (versionRange) => versionRange === "next" || eqMajor(versionRange, 3)
    },
    matcherFunction: ({ dependencies }) => {
      return dependencies.some(Boolean);
    }
  },
  {
    preset: "EMBER" /* EMBER */,
    dependencies: ["ember-cli"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    preset: "NEXTJS" /* NEXTJS */,
    dependencies: {
      next: (versionRange) => eqMajor(versionRange, 9) || gtMajor(versionRange, 9)
    },
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    preset: "QWIK" /* QWIK */,
    dependencies: ["@builder.io/qwik"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    preset: "REACT_PROJECT" /* REACT_PROJECT */,
    peerDependencies: ["react"],
    matcherFunction: ({ peerDependencies }) => {
      return peerDependencies.every(Boolean);
    }
  },
  {
    preset: "REACT_NATIVE" /* REACT_NATIVE */,
    dependencies: ["react-native", "react-native-scripts"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.some(Boolean);
    }
  },
  {
    preset: "REACT_SCRIPTS" /* REACT_SCRIPTS */,
    // For projects using a custom/forked `react-scripts` package.
    files: ["/node_modules/.bin/react-scripts"],
    // For standard CRA projects
    dependencies: ["react-scripts"],
    matcherFunction: ({ dependencies, files }) => {
      return dependencies.every(Boolean) || files.every(Boolean);
    }
  },
  {
    preset: "ANGULAR" /* ANGULAR */,
    dependencies: ["@angular/core"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    preset: "WEB_COMPONENTS" /* WEB_COMPONENTS */,
    dependencies: ["lit-element", "lit-html", "lit"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.some(Boolean);
    }
  },
  {
    preset: "PREACT" /* PREACT */,
    dependencies: ["preact"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    // TODO: This only works because it is before the SVELTE template. could be more explicit
    preset: "SVELTEKIT" /* SVELTEKIT */,
    dependencies: ["@sveltejs/kit"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    preset: "SVELTE" /* SVELTE */,
    dependencies: ["svelte"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    preset: "SOLID" /* SOLID */,
    dependencies: ["solid-js"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  // DO NOT MOVE ANY TEMPLATES BELOW THIS LINE
  // React is part of every Template, after Storybook is initialized once
  {
    preset: "WEBPACK_REACT" /* WEBPACK_REACT */,
    dependencies: ["react", "webpack"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  },
  {
    preset: "REACT" /* REACT */,
    dependencies: ["react"],
    matcherFunction: ({ dependencies }) => {
      return dependencies.every(Boolean);
    }
  }
];
var unsupportedTemplate = {
  preset: "UNSUPPORTED" /* UNSUPPORTED */,
  dependencies: {
    // TODO(blaine): Remove when we support Nuxt 3
    // nuxt: (versionRange) => eqMajor(versionRange, 3), this wasted 2 hours of my life
  },
  matcherFunction: ({ dependencies }) => {
    return dependencies.some(Boolean);
  }
};
var notInstallableProjectTypes = ["UNDETECTED" /* UNDETECTED */, "UNSUPPORTED" /* UNSUPPORTED */];
var installableProjectTypes = Object.values(ProjectType).filter((type) => !notInstallableProjectTypes.includes(type)).map((type) => type.toLowerCase());

// src/dirs.ts
function getCliDir() {
  return dirname(__require.resolve("@storybook/cli/package.json"));
}
var resolveUsingBranchInstall = async (packageManager, request) => {
  const tempDirectory = tempy.directory();
  const name = request;
  const version = versions_default[name] || await packageManager.latestVersion(request);
  const url = getNpmTarballUrl(request, version, {
    registry: await packageManager.getRegistryURL()
  });
  await downloadTarball({ url, dir: tempDirectory });
  return join(tempDirectory, "package");
};
async function getRendererDir(packageManager, renderer) {
  const externalFramework = externalFrameworks.find((framework) => framework.name === renderer);
  const frameworkPackageName = externalFramework?.renderer || externalFramework?.packageName || `@storybook/${renderer}`;
  const packageJsonPath = join(frameworkPackageName, "package.json");
  const errors = [];
  try {
    return dirname(
      __require.resolve(packageJsonPath, {
        paths: [process.cwd()]
      })
    );
  } catch (e) {
    errors.push(e);
  }
  try {
    return await resolveUsingBranchInstall(packageManager, frameworkPackageName);
  } catch (e) {
    errors.push(e);
  }
  throw new Error(`Cannot find ${packageJsonPath}, ${errors.map((e) => e.stack).join("\n\n")}`);
}

// src/helpers.ts
var logger = console;
var commandLog = (message) => {
  process.stdout.write(chalk.cyan(" \u2022 ") + message);
  return (errorMessage, errorInfo) => {
    if (errorMessage) {
      process.stdout.write(`. ${chalk.red("\u2716")}
`);
      logger.error(`
     ${chalk.red(errorMessage)}`);
      if (!errorInfo) {
        return;
      }
      const newErrorInfo = errorInfo.split("\n").map((line) => `     ${chalk.dim(line)}`).join("\n");
      logger.error(`${newErrorInfo}
`);
      return;
    }
    process.stdout.write(`. ${chalk.green("\u2713")}
`);
  };
};
function paddedLog(message) {
  const newMessage = message.split("\n").map((line) => `    ${line}`).join("\n");
  logger.log(newMessage);
}
function getChars(char, amount) {
  let line = "";
  for (let lc = 0; lc < amount; lc += 1) {
    line += char;
  }
  return line;
}
function codeLog(codeLines, leftPadAmount) {
  let maxLength = 0;
  const newLines = codeLines.map((line) => {
    maxLength = line.length > maxLength ? line.length : maxLength;
    return line;
  });
  const finalResult = newLines.map((line) => {
    const rightPadAmount = maxLength - line.length;
    let newLine = line + getChars(" ", rightPadAmount);
    newLine = getChars(" ", leftPadAmount || 2) + chalk.inverse(` ${newLine} `);
    return newLine;
  }).join("\n");
  logger.log(finalResult);
}
async function getBabelDependencies(packageManager, packageJson) {
  const dependenciesToAdd = [];
  let babelLoaderVersion = "^8.0.0-0";
  const babelCoreVersion = packageJson.dependencies["babel-core"] || packageJson.devDependencies["babel-core"];
  if (!babelCoreVersion) {
    if (!packageJson.dependencies["@babel/core"] && !packageJson.devDependencies["@babel/core"]) {
      const babelCoreInstallVersion = await packageManager.getVersion("@babel/core");
      dependenciesToAdd.push(`@babel/core@${babelCoreInstallVersion}`);
    }
  } else {
    const latestCompatibleBabelVersion = await packageManager.latestVersion(
      "babel-core",
      babelCoreVersion
    );
    if (satisfies(latestCompatibleBabelVersion, "^6.0.0")) {
      babelLoaderVersion = "^7.0.0";
    }
  }
  if (!packageJson.dependencies["babel-loader"] && !packageJson.devDependencies["babel-loader"]) {
    const babelLoaderInstallVersion = await packageManager.getVersion(
      "babel-loader",
      babelLoaderVersion
    );
    dependenciesToAdd.push(`babel-loader@${babelLoaderInstallVersion}`);
  }
  return dependenciesToAdd;
}
function copyTemplate(templateRoot, destination = ".") {
  const templateDir = path2.resolve(templateRoot, `template-csf/`);
  if (!fs2.existsSync(templateDir)) {
    throw new Error(`Couldn't find template dir`);
  }
  fse.copySync(templateDir, destination, { overwrite: true });
}
var frameworkToRenderer = {
  angular: "angular",
  ember: "ember",
  html: "html",
  nextjs: "react",
  preact: "preact",
  qwik: "qwik",
  react: "react",
  "react-native": "react",
  server: "react",
  solid: "solid",
  svelte: "svelte",
  sveltekit: "svelte",
  vue: "vue",
  vue3: "vue",
  nuxt: "vue",
  "web-components": "web-components"
};
async function copyTemplateFiles({
  packageManager,
  renderer,
  language,
  destination,
  includeCommonAssets = true
}) {
  const languageFolderMapping = {
    // keeping this for backwards compatibility in case community packages are using it
    typescript: "ts",
    ["javascript" /* JAVASCRIPT */]: "js",
    ["typescript-3-8" /* TYPESCRIPT_3_8 */]: "ts-3-8",
    ["typescript-4-9" /* TYPESCRIPT_4_9 */]: "ts-4-9"
  };
  const templatePath = async () => {
    const baseDir = await getRendererDir(packageManager, renderer);
    const assetsDir = join(baseDir, "template", "cli");
    const assetsLanguage = join(assetsDir, languageFolderMapping[language]);
    const assetsJS = join(assetsDir, languageFolderMapping["javascript" /* JAVASCRIPT */]);
    const assetsTS = join(assetsDir, languageFolderMapping.typescript);
    const assetsTS38 = join(assetsDir, languageFolderMapping["typescript-3-8" /* TYPESCRIPT_3_8 */]);
    if (await fse.pathExists(assetsLanguage)) {
      return assetsLanguage;
    }
    if (language === "typescript-4-9" /* TYPESCRIPT_4_9 */ && await fse.pathExists(assetsTS38)) {
      return assetsTS38;
    }
    if (await fse.pathExists(assetsTS)) {
      return assetsTS;
    }
    if (await fse.pathExists(assetsJS)) {
      return assetsJS;
    }
    if (await fse.pathExists(assetsDir)) {
      return assetsDir;
    }
    throw new Error(`Unsupported renderer: ${renderer} (${baseDir})`);
  };
  const targetPath = async () => {
    if (await fse.pathExists("./src")) {
      return "./src/stories";
    }
    return "./stories";
  };
  const destinationPath = destination ?? await targetPath();
  if (includeCommonAssets) {
    await fse.copy(join(getCliDir(), "rendererAssets", "common"), destinationPath, {
      overwrite: true
    });
  }
  await fse.copy(await templatePath(), destinationPath, { overwrite: true });
  if (includeCommonAssets) {
    const rendererType = frameworkToRenderer[renderer] || "react";
    await adjustTemplate(join(destinationPath, "Configure.mdx"), { renderer: rendererType });
  }
}
async function adjustTemplate(templatePath, templateData) {
  let template = await fse.readFile(templatePath, "utf8");
  Object.keys(templateData).forEach((key) => {
    template = template.replaceAll(`{{${key}}}`, `${templateData[key]}`);
  });
  await fse.writeFile(templatePath, template);
}
function getStorybookVersionSpecifier(packageJson) {
  const allDeps = { ...packageJson.dependencies, ...packageJson.devDependencies };
  const storybookPackage = Object.keys(allDeps).find(
    (name) => {
      return versions_default[name];
    }
  );
  if (!storybookPackage) {
    throw new Error(`Couldn't find any official storybook packages in package.json`);
  }
  return allDeps[storybookPackage];
}
async function isNxProject() {
  return findUp.sync("nx.json");
}

// src/HandledError.ts
var HandledError = class extends Error {
  constructor(messageOrError) {
    super(typeof messageOrError === "string" ? messageOrError : messageOrError.message);
    this.handled = true;
    if (typeof messageOrError !== "string")
      this.cause = messageOrError;
  }
};

// src/js-package-manager/JsPackageManager.ts
var logger2 = console;
function getPackageDetails(pkg) {
  const idx = pkg.lastIndexOf("@");
  if (idx <= 0) {
    return [pkg, void 0];
  }
  const packageName = pkg.slice(0, idx);
  const packageVersion = pkg.slice(idx + 1);
  return [packageName, packageVersion];
}
var JsPackageManager = class {
  // NOTE: for some reason yarn prefers the npm registry in
  // local development, so always use npm
  async setRegistryURL(url) {
    if (url) {
      await this.executeCommand({ command: "npm", args: ["config", "set", "registry", url] });
    } else {
      await this.executeCommand({ command: "npm", args: ["config", "delete", "registry"] });
    }
  }
  async getRegistryURL() {
    const res = await this.executeCommand({ command: "npm", args: ["config", "get", "registry"] });
    const url = res.trim();
    return url === "undefined" ? void 0 : url;
  }
  constructor(options) {
    this.cwd = options?.cwd || process.cwd();
  }
  /** Detect whether Storybook gets initialized in a monorepository/workspace environment
   * The cwd doesn't have to be the root of the monorepo, it can be a subdirectory
   * @returns true, if Storybook is initialized inside a monorepository/workspace
   */
  isStorybookInMonorepo() {
    let cwd = process.cwd();
    while (true) {
      try {
        const turboJsonPath = `${cwd}/turbo.json`;
        const rushJsonPath = `${cwd}/rush.json`;
        if (fs2.existsSync(turboJsonPath) || fs2.existsSync(rushJsonPath)) {
          return true;
        }
        const packageJsonPath = __require.resolve(`${cwd}/package.json`);
        const packageJsonFile = readFileSync(packageJsonPath, "utf8");
        const packageJson = JSON.parse(packageJsonFile);
        if (packageJson.workspaces) {
          return true;
        }
      } catch (err) {
      }
      const parentDir = path2.dirname(cwd);
      if (parentDir === cwd) {
        break;
      }
      cwd = parentDir;
    }
    return false;
  }
  /**
   * Install dependencies listed in `package.json`
   */
  async installDependencies() {
    let done = commandLog("Preparing to install dependencies");
    done();
    logger2.log();
    logger2.log();
    done = commandLog("Installing dependencies");
    try {
      await this.runInstall();
      done();
    } catch (e) {
      done("An error occurred while installing dependencies.");
      throw new HandledError(e);
    }
  }
  packageJsonPath() {
    return path2.resolve(this.cwd, "package.json");
  }
  async readPackageJson() {
    const packageJsonPath = this.packageJsonPath();
    if (!fs2.existsSync(packageJsonPath)) {
      throw new Error(`Could not read package.json file at ${packageJsonPath}`);
    }
    const jsonContent = await readFile(packageJsonPath, "utf8");
    return JSON.parse(jsonContent);
  }
  async writePackageJson(packageJson) {
    const packageJsonToWrite = { ...packageJson };
    if (packageJsonToWrite.dependencies && Object.keys(packageJsonToWrite.dependencies).length === 0) {
      delete packageJsonToWrite.dependencies;
    }
    if (packageJsonToWrite.devDependencies && Object.keys(packageJsonToWrite.devDependencies).length === 0) {
      delete packageJsonToWrite.devDependencies;
    }
    if (packageJsonToWrite.peerDependencies && Object.keys(packageJsonToWrite.peerDependencies).length === 0) {
      delete packageJsonToWrite.peerDependencies;
    }
    const content = `${JSON.stringify(packageJsonToWrite, null, 2)}
`;
    await writeFile(this.packageJsonPath(), content, "utf8");
  }
  /**
   * Read the `package.json` file available in the directory the command was call from
   * If there is no `package.json` it will create one.
   */
  async retrievePackageJson() {
    let packageJson;
    try {
      packageJson = await this.readPackageJson();
    } catch (err) {
      if (err.message.includes("Could not read package.json")) {
        await this.initPackageJson();
        packageJson = await this.readPackageJson();
      } else {
        throw new Error(
          dedent`
            There was an error while reading the package.json file at ${this.packageJsonPath()}: ${err.message}
            Please fix the error and try again.
          `
        );
      }
    }
    return {
      ...packageJson,
      dependencies: { ...packageJson.dependencies },
      devDependencies: { ...packageJson.devDependencies },
      peerDependencies: { ...packageJson.peerDependencies }
    };
  }
  async getAllDependencies() {
    const { dependencies, devDependencies, peerDependencies } = await this.retrievePackageJson();
    return {
      ...dependencies,
      ...devDependencies,
      ...peerDependencies
    };
  }
  /**
   * Add dependencies to a project using `yarn add` or `npm install`.
   *
   * @param {Object} options contains `skipInstall`, `packageJson` and `installAsDevDependencies` which we use to determine how we install packages.
   * @param {Array} dependencies contains a list of packages to add.
   * @example
   * addDependencies(options, [
   *   `@storybook/react@${storybookVersion}`,
   *   `@storybook/addon-actions@${actionsVersion}`,
   *   `@storybook/addon-links@${linksVersion}`,
   *   `@storybook/preview-api@${addonsVersion}`,
   * ]);
   */
  async addDependencies(options, dependencies) {
    const { skipInstall } = options;
    if (skipInstall) {
      const { packageJson } = options;
      const dependenciesMap = dependencies.reduce((acc, dep) => {
        const [packageName, packageVersion] = getPackageDetails(dep);
        return { ...acc, [packageName]: packageVersion };
      }, {});
      if (options.installAsDevDependencies) {
        packageJson.devDependencies = {
          ...packageJson.devDependencies,
          ...dependenciesMap
        };
      } else {
        packageJson.dependencies = {
          ...packageJson.dependencies,
          ...dependenciesMap
        };
      }
      await this.writePackageJson(packageJson);
    } else {
      try {
        await this.runAddDeps(dependencies, options.installAsDevDependencies);
      } catch (e) {
        logger2.error("\nAn error occurred while installing dependencies:");
        logger2.log(e.message);
        throw new HandledError(e);
      }
    }
  }
  /**
   * Remove dependencies from a project using `yarn remove` or `npm uninstall`.
   *
   * @param {Object} options contains `skipInstall`, `packageJson` and `installAsDevDependencies` which we use to determine how we install packages.
   * @param {Array} dependencies contains a list of packages to remove.
   * @example
   * removeDependencies(options, [
   *   `@storybook/react`,
   *   `@storybook/addon-actions`,
   * ]);
   */
  async removeDependencies(options, dependencies) {
    const { skipInstall } = options;
    if (skipInstall) {
      const { packageJson } = options;
      dependencies.forEach((dep) => {
        if (packageJson.devDependencies) {
          delete packageJson.devDependencies[dep];
        }
        if (packageJson.dependencies) {
          delete packageJson.dependencies[dep];
        }
      });
      await this.writePackageJson(packageJson);
    } else {
      try {
        await this.runRemoveDeps(dependencies);
      } catch (e) {
        logger2.error("An error occurred while removing dependencies.");
        logger2.log(e.message);
        throw new HandledError(e);
      }
    }
  }
  /**
   * Return an array of strings matching following format: `<package_name>@<package_latest_version>`
   *
   * @param packages
   */
  getVersionedPackages(packages) {
    return Promise.all(
      packages.map(async (pkg) => {
        const [packageName, packageVersion] = getPackageDetails(pkg);
        return `${packageName}@${await this.getVersion(packageName, packageVersion)}`;
      })
    );
  }
  /**
   * Return an array of string standing for the latest version of the input packages.
   * To be able to identify which version goes with which package the order of the input array is keep.
   *
   * @param packageNames
   */
  getVersions(...packageNames) {
    return Promise.all(
      packageNames.map((packageName) => {
        return this.getVersion(packageName);
      })
    );
  }
  /**
   * Return the latest version of the input package available on npmjs registry.
   * If constraint are provided it return the latest version matching the constraints.
   *
   * For `@storybook/*` packages the latest version is retrieved from `cli/src/versions.json` file directly
   *
   * @param packageName The name of the package
   * @param constraint A valid semver constraint, example: '1.x || >=2.5.0 || 5.0.0 - 7.2.3'
   */
  async getVersion(packageName, constraint) {
    let current;
    if (/(@storybook|^sb$|^storybook$)/.test(packageName)) {
      current = versions_default[packageName];
    }
    let latest;
    try {
      latest = await this.latestVersion(packageName, constraint);
    } catch (e) {
      if (current) {
        logger2.warn(`
     ${chalk.yellow(e.message)}`);
        return current;
      }
      logger2.error(`
     ${chalk.red(e.message)}`);
      throw new HandledError(e);
    }
    const versionToUse = current && (!constraint || satisfies(current, constraint)) && gt(current, latest) ? current : latest;
    return `^${versionToUse}`;
  }
  /**
   * Get the latest version of the package available on npmjs.com.
   * If constraint is set then it returns a version satisfying it, otherwise the latest version available is returned.
   *
   * @param packageName Name of the package
   * @param constraint Version range to use to constraint the returned version
   */
  async latestVersion(packageName, constraint) {
    if (!constraint) {
      return this.runGetVersions(packageName, false);
    }
    const versions = await this.runGetVersions(packageName, true);
    return versions.reverse().find((version) => satisfies(version, constraint));
  }
  async addStorybookCommandInScripts(options) {
    const sbPort = options?.port ?? 6006;
    const storybookCmd = `storybook dev -p ${sbPort}`;
    const buildStorybookCmd = `storybook build`;
    const preCommand = options?.preCommand ? this.getRunCommand(options.preCommand) : void 0;
    await this.addScripts({
      storybook: [preCommand, storybookCmd].filter(Boolean).join(" && "),
      "build-storybook": [preCommand, buildStorybookCmd].filter(Boolean).join(" && ")
    });
  }
  async addScripts(scripts) {
    const packageJson = await this.retrievePackageJson();
    await this.writePackageJson({
      ...packageJson,
      scripts: {
        ...packageJson.scripts,
        ...scripts
      }
    });
  }
  async addPackageResolutions(versions) {
    const packageJson = await this.retrievePackageJson();
    const resolutions = this.getResolutions(packageJson, versions);
    this.writePackageJson({ ...packageJson, ...resolutions });
  }
  executeCommandSync({
    command,
    args = [],
    stdio,
    cwd,
    ignoreError = false,
    env,
    ...execaOptions
  }) {
    try {
      const commandResult = sync(command, args, {
        cwd: cwd ?? this.cwd,
        stdio: stdio ?? "pipe",
        encoding: "utf-8",
        shell: true,
        cleanup: true,
        env,
        ...execaOptions
      });
      return commandResult.stdout ?? "";
    } catch (err) {
      if (ignoreError !== true) {
        throw err;
      }
      return "";
    }
  }
  async executeCommand({
    command: command$1,
    args = [],
    stdio,
    cwd,
    ignoreError = false,
    env,
    ...execaOptions
  }) {
    try {
      const commandResult = await command([command$1, ...args].join(" "), {
        cwd: cwd ?? this.cwd,
        stdio: stdio ?? "pipe",
        encoding: "utf-8",
        shell: true,
        cleanup: true,
        env,
        ...execaOptions
      });
      return commandResult.stdout ?? "";
    } catch (err) {
      if (ignoreError !== true) {
        throw err;
      }
      return "";
    }
  }
};
function parseList(str) {
  return str.split(",").map((item) => item.trim()).filter((item) => item.length > 0);
}
async function getStorybookVersion(packageManager) {
  const packages = (await Promise.all(
    Object.keys(rendererPackages).map(async (pkg) => ({
      name: pkg,
      version: await packageManager.getPackageVersion(pkg)
    }))
  )).filter(({ version }) => !!version);
  return packages[0]?.version;
}
function getEnvConfig(program, configEnv) {
  Object.keys(configEnv).forEach((fieldName) => {
    const envVarName = configEnv[fieldName];
    const envVarValue = process.env[envVarName];
    if (envVarValue) {
      program[fieldName] = envVarValue;
    }
  });
}
var createLogStream = async (logFileName = "storybook.log") => {
  const finalLogPath = join(process.cwd(), logFileName);
  const temporaryLogPath = tempy__default.file({ name: logFileName });
  const logStream = createWriteStream(temporaryLogPath, { encoding: "utf8" });
  return new Promise((resolve, reject) => {
    logStream.once("open", () => {
      const moveLogFile = async () => move(temporaryLogPath, finalLogPath, { overwrite: true });
      const clearLogFile = async () => writeFile(temporaryLogPath, "");
      const removeLogFile = async () => remove(temporaryLogPath);
      const readLogFile = async () => {
        return readFile(temporaryLogPath, "utf8");
      };
      resolve({ logStream, moveLogFile, clearLogFile, removeLogFile, readLogFile });
    });
    logStream.once("error", reject);
  });
};
var NPM_ERROR_REGEX = /npm ERR! code (\w+)/;
var NPM_ERROR_CODES = {
  E401: "Authentication failed or is required.",
  E403: "Access to the resource is forbidden.",
  E404: "Requested resource not found.",
  EACCES: "Permission issue.",
  EAI_FAIL: "DNS lookup failed.",
  EBADENGINE: "Engine compatibility check failed.",
  EBADPLATFORM: "Platform not supported.",
  ECONNREFUSED: "Connection refused.",
  ECONNRESET: "Connection reset.",
  EEXIST: "File or directory already exists.",
  EINVALIDTYPE: "Invalid type encountered.",
  EISGIT: "Git operation failed or conflicts with an existing file.",
  EJSONPARSE: "Error parsing JSON data.",
  EMISSINGARG: "Required argument missing.",
  ENEEDAUTH: "Authentication needed.",
  ENOAUDIT: "No audit available.",
  ENOENT: "File or directory does not exist.",
  ENOGIT: "Git not found or failed to run.",
  ENOLOCK: "Lockfile missing.",
  ENOSPC: "Insufficient disk space.",
  ENOTFOUND: "Resource not found.",
  EOTP: "One-time password required.",
  EPERM: "Permission error.",
  EPUBLISHCONFLICT: "Conflict during package publishing.",
  ERESOLVE: "Dependency resolution error.",
  EROFS: "File system is read-only.",
  ERR_SOCKET_TIMEOUT: "Socket timed out.",
  ETARGET: "Package target not found.",
  ETIMEDOUT: "Operation timed out.",
  ETOOMANYARGS: "Too many arguments provided.",
  EUNKNOWNTYPE: "Unknown type encountered."
};
var NPMProxy = class extends JsPackageManager {
  constructor() {
    super(...arguments);
    this.type = "npm";
  }
  async initPackageJson() {
    await this.executeCommand({ command: "npm", args: ["init", "-y"] });
  }
  getRunStorybookCommand() {
    return "npm run storybook";
  }
  getRunCommand(command) {
    return `npm run ${command}`;
  }
  async getNpmVersion() {
    return this.executeCommand({ command: "npm", args: ["--version"] });
  }
  async getPackageJSON(packageName, basePath = this.cwd) {
    const packageJsonPath = await sync$1(
      (dir) => {
        const possiblePath = path2.join(dir, "node_modules", packageName, "package.json");
        return existsSync(possiblePath) ? possiblePath : void 0;
      },
      { cwd: basePath }
    );
    if (!packageJsonPath) {
      return null;
    }
    const packageJson = JSON.parse(readFileSync$1(packageJsonPath, "utf-8"));
    return packageJson;
  }
  async getPackageVersion(packageName, basePath = this.cwd) {
    const packageJson = await this.getPackageJSON(packageName, basePath);
    return packageJson ? semver.coerce(packageJson.version)?.version ?? null : null;
  }
  getInstallArgs() {
    if (!this.installArgs) {
      this.installArgs = [];
    }
    return this.installArgs;
  }
  runPackageCommandSync(command, args, cwd, stdio) {
    return this.executeCommandSync({
      command: "npm",
      args: ["exec", "--", command, ...args],
      cwd,
      stdio
    });
  }
  async runPackageCommand(command, args, cwd) {
    return this.executeCommand({
      command: "npm",
      args: ["exec", "--", command, ...args],
      cwd
    });
  }
  async findInstallations() {
    const pipeToNull = platform() === "win32" ? "2>NUL" : "2>/dev/null";
    const commandResult = await this.executeCommand({
      command: "npm",
      args: ["ls", "--json", "--depth=99", pipeToNull],
      // ignore errors, because npm ls will exit with code 1 if there are e.g. unmet peer dependencies
      ignoreError: true
    });
    try {
      const parsedOutput = JSON.parse(commandResult);
      return this.mapDependencies(parsedOutput);
    } catch (e) {
      return void 0;
    }
  }
  getResolutions(packageJson, versions) {
    return {
      overrides: {
        ...packageJson.overrides,
        ...versions
      }
    };
  }
  async runInstall() {
    await this.executeCommand({
      command: "npm",
      args: ["install", ...this.getInstallArgs()],
      stdio: "inherit"
    });
  }
  async runAddDeps(dependencies, installAsDevDependencies) {
    const { logStream, readLogFile, moveLogFile, removeLogFile } = await createLogStream();
    let args = [...dependencies];
    if (installAsDevDependencies) {
      args = ["-D", ...args];
    }
    try {
      await this.executeCommand({
        command: "npm",
        args: ["install", ...args, ...this.getInstallArgs()],
        stdio: ["ignore", logStream, logStream]
      });
    } catch (err) {
      const stdout = await readLogFile();
      const errorMessage = this.parseErrorFromLogs(stdout);
      await moveLogFile();
      throw new Error(
        dedent`${errorMessage}
        
        Please check the logfile generated at ./storybook.log for troubleshooting and try again.`
      );
    }
    await removeLogFile();
  }
  async runRemoveDeps(dependencies) {
    const args = [...dependencies];
    await this.executeCommand({
      command: "npm",
      args: ["uninstall", ...this.getInstallArgs(), ...args],
      stdio: "inherit"
    });
  }
  async runGetVersions(packageName, fetchAllVersions) {
    const args = [fetchAllVersions ? "versions" : "version", "--json"];
    const commandResult = await this.executeCommand({
      command: "npm",
      args: ["info", packageName, ...args]
    });
    try {
      const parsedOutput = JSON.parse(commandResult);
      if (parsedOutput.error) {
        throw new Error(parsedOutput.error.summary);
      } else {
        return parsedOutput;
      }
    } catch (e) {
      throw new Error(`Unable to find versions of ${packageName} using npm`);
    }
  }
  mapDependencies(input) {
    const acc = {};
    const existingVersions = {};
    const duplicatedDependencies = {};
    const recurse = ([name, packageInfo]) => {
      if (!name || !name.includes("storybook"))
        return;
      const value = {
        version: packageInfo.version,
        location: ""
      };
      if (!existingVersions[name]?.includes(value.version)) {
        if (acc[name]) {
          acc[name].push(value);
        } else {
          acc[name] = [value];
        }
        existingVersions[name] = sort([...existingVersions[name] || [], value.version]);
        if (existingVersions[name].length > 1) {
          duplicatedDependencies[name] = existingVersions[name];
        }
      }
      if (packageInfo.dependencies) {
        Object.entries(packageInfo.dependencies).forEach(recurse);
      }
    };
    Object.entries(input.dependencies).forEach(recurse);
    return {
      dependencies: acc,
      duplicatedDependencies,
      infoCommand: "npm ls --depth=1"
    };
  }
  parseErrorFromLogs(logs) {
    let finalMessage = "NPM error";
    const match = logs.match(NPM_ERROR_REGEX);
    if (match) {
      const errorCode = match[1];
      if (errorCode) {
        finalMessage = `${finalMessage} ${errorCode}`;
      }
      const errorMessage = NPM_ERROR_CODES[errorCode];
      if (errorMessage) {
        finalMessage = `${finalMessage} - ${errorMessage}`;
      }
    }
    return finalMessage.trim();
  }
};
var PNPM_ERROR_REGEX = /(ELIFECYCLE|ERR_PNPM_[A-Z_]+)\s+(.*)/i;
var PNPMProxy = class extends JsPackageManager {
  constructor() {
    super(...arguments);
    this.type = "pnpm";
  }
  detectWorkspaceRoot() {
    const CWD = process.cwd();
    const pnpmWorkspaceYaml = `${CWD}/pnpm-workspace.yaml`;
    return pathExistsSync(pnpmWorkspaceYaml);
  }
  async initPackageJson() {
    await this.executeCommand({
      command: "pnpm",
      args: ["init"]
    });
  }
  getRunStorybookCommand() {
    return "pnpm run storybook";
  }
  getRunCommand(command) {
    return `pnpm run ${command}`;
  }
  async getPnpmVersion() {
    return this.executeCommand({
      command: "pnpm",
      args: ["--version"]
    });
  }
  getInstallArgs() {
    if (!this.installArgs) {
      this.installArgs = [];
      if (this.detectWorkspaceRoot()) {
        this.installArgs.push("-w");
      }
    }
    return this.installArgs;
  }
  runPackageCommandSync(command, args, cwd, stdio) {
    return this.executeCommandSync({
      command: "pnpm",
      args: ["exec", command, ...args],
      cwd,
      stdio
    });
  }
  async runPackageCommand(command, args, cwd) {
    return this.executeCommand({
      command: "pnpm",
      args: ["exec", command, ...args],
      cwd
    });
  }
  async findInstallations(pattern) {
    const commandResult = await this.executeCommand({
      command: "pnpm",
      args: ["list", pattern.map((p) => `"${p}"`).join(" "), "--json", "--depth=99"]
    });
    try {
      const parsedOutput = JSON.parse(commandResult);
      return this.mapDependencies(parsedOutput);
    } catch (e) {
      return void 0;
    }
  }
  async getPackageJSON(packageName, basePath = this.cwd) {
    const pnpapiPath = sync$1([".pnp.js", ".pnp.cjs"], { cwd: basePath });
    if (pnpapiPath) {
      try {
        const pnpApi = __require(pnpapiPath);
        const resolvedPath = await pnpApi.resolveToUnqualified(packageName, basePath, {
          considerBuiltins: false
        });
        const pkgLocator = pnpApi.findPackageLocator(resolvedPath);
        const pkg = pnpApi.getPackageInformation(pkgLocator);
        const packageJSON = JSON.parse(
          fs2.readFileSync(path2.join(pkg.packageLocation, "package.json"), "utf-8")
        );
        return packageJSON;
      } catch (error) {
        if (error.code !== "MODULE_NOT_FOUND") {
          console.error("Error while fetching package version in PNPM PnP mode:", error);
        }
        return null;
      }
    }
    const packageJsonPath = await sync$1(
      (dir) => {
        const possiblePath = path2.join(dir, "node_modules", packageName, "package.json");
        return fs2.existsSync(possiblePath) ? possiblePath : void 0;
      },
      { cwd: basePath }
    );
    if (!packageJsonPath) {
      return null;
    }
    return JSON.parse(fs2.readFileSync(packageJsonPath, "utf-8"));
  }
  async getPackageVersion(packageName, basePath = this.cwd) {
    const packageJSON = await this.getPackageJSON(packageName, basePath);
    return packageJSON ? semver.coerce(packageJSON.version)?.version ?? null : null;
  }
  getResolutions(packageJson, versions) {
    return {
      overrides: {
        ...packageJson.overrides,
        ...versions
      }
    };
  }
  async runInstall() {
    await this.executeCommand({
      command: "pnpm",
      args: ["install", ...this.getInstallArgs()],
      stdio: "inherit"
    });
  }
  async runAddDeps(dependencies, installAsDevDependencies) {
    let args = [...dependencies];
    if (installAsDevDependencies) {
      args = ["-D", ...args];
    }
    const { logStream, readLogFile, moveLogFile, removeLogFile } = await createLogStream();
    try {
      await this.executeCommand({
        command: "pnpm",
        args: ["add", ...args, ...this.getInstallArgs()],
        stdio: ["ignore", logStream, logStream]
      });
    } catch (err) {
      const stdout = await readLogFile();
      const errorMessage = this.parseErrorFromLogs(stdout);
      await moveLogFile();
      throw new Error(
        dedent`${errorMessage}
        
        Please check the logfile generated at ./storybook.log for troubleshooting and try again.`
      );
    }
    await removeLogFile();
  }
  async runRemoveDeps(dependencies) {
    const args = [...dependencies];
    await this.executeCommand({
      command: "pnpm",
      args: ["remove", ...args, ...this.getInstallArgs()],
      stdio: "inherit"
    });
  }
  async runGetVersions(packageName, fetchAllVersions) {
    const args = [fetchAllVersions ? "versions" : "version", "--json"];
    const commandResult = await this.executeCommand({
      command: "pnpm",
      args: ["info", packageName, ...args]
    });
    try {
      const parsedOutput = JSON.parse(commandResult);
      if (parsedOutput.error) {
        throw new Error(parsedOutput.error.summary);
      } else {
        return parsedOutput;
      }
    } catch (e) {
      throw new Error(`Unable to find versions of ${packageName} using pnpm`);
    }
  }
  mapDependencies(input) {
    const acc = {};
    const existingVersions = {};
    const duplicatedDependencies = {};
    const items = input.reduce((curr, item) => {
      const { devDependencies, dependencies, peerDependencies } = item;
      const allDependencies = { ...devDependencies, ...dependencies, ...peerDependencies };
      return Object.assign(curr, allDependencies);
    }, {});
    const recurse = ([name, packageInfo]) => {
      if (!name || !name.includes("storybook"))
        return;
      const value = {
        version: packageInfo.version,
        location: ""
      };
      if (!existingVersions[name]?.includes(value.version)) {
        if (acc[name]) {
          acc[name].push(value);
        } else {
          acc[name] = [value];
        }
        existingVersions[name] = [...existingVersions[name] || [], value.version];
        if (existingVersions[name].length > 1) {
          duplicatedDependencies[name] = existingVersions[name];
        }
      }
      if (packageInfo.dependencies) {
        Object.entries(packageInfo.dependencies).forEach(recurse);
      }
    };
    Object.entries(items).forEach(recurse);
    return {
      dependencies: acc,
      duplicatedDependencies,
      infoCommand: "pnpm list --depth=1"
    };
  }
  parseErrorFromLogs(logs) {
    let finalMessage = "PNPM error";
    const match = logs.match(PNPM_ERROR_REGEX);
    if (match) {
      const [errorCode] = match;
      if (errorCode) {
        finalMessage = `${finalMessage} ${errorCode}`;
      }
    }
    return finalMessage.trim();
  }
};

// src/js-package-manager/util.ts
var parsePackageData = (packageName = "") => {
  const [first, second, third] = packageName.trim().split("@");
  const version = (third || second).replace("npm:", "");
  const name = third ? `@${second}` : first;
  const value = { version, location: "" };
  return { name, value };
};

// src/js-package-manager/Yarn2Proxy.ts
var YARN2_ERROR_REGEX = /(YN\d{4}):.*?Error:\s+(.*)/i;
var YARN2_ERROR_CODES = {
  YN0000: "UNNAMED",
  YN0001: "EXCEPTION",
  YN0002: "MISSING_PEER_DEPENDENCY",
  YN0003: "CYCLIC_DEPENDENCIES",
  YN0004: "DISABLED_BUILD_SCRIPTS",
  YN0005: "BUILD_DISABLED",
  YN0006: "SOFT_LINK_BUILD",
  YN0007: "MUST_BUILD",
  YN0008: "MUST_REBUILD",
  YN0009: "BUILD_FAILED",
  YN0010: "RESOLVER_NOT_FOUND",
  YN0011: "FETCHER_NOT_FOUND",
  YN0012: "LINKER_NOT_FOUND",
  YN0013: "FETCH_NOT_CACHED",
  YN0014: "YARN_IMPORT_FAILED",
  YN0015: "REMOTE_INVALID",
  YN0016: "REMOTE_NOT_FOUND",
  YN0017: "RESOLUTION_PACK",
  YN0018: "CACHE_CHECKSUM_MISMATCH",
  YN0019: "UNUSED_CACHE_ENTRY",
  YN0020: "MISSING_LOCKFILE_ENTRY",
  YN0021: "WORKSPACE_NOT_FOUND",
  YN0022: "TOO_MANY_MATCHING_WORKSPACES",
  YN0023: "CONSTRAINTS_MISSING_DEPENDENCY",
  YN0024: "CONSTRAINTS_INCOMPATIBLE_DEPENDENCY",
  YN0025: "CONSTRAINTS_EXTRANEOUS_DEPENDENCY",
  YN0026: "CONSTRAINTS_INVALID_DEPENDENCY",
  YN0027: "CANT_SUGGEST_RESOLUTIONS",
  YN0028: "FROZEN_LOCKFILE_EXCEPTION",
  YN0029: "CROSS_DRIVE_VIRTUAL_LOCAL",
  YN0030: "FETCH_FAILED",
  YN0031: "DANGEROUS_NODE_MODULES",
  YN0032: "NODE_GYP_INJECTED",
  YN0046: "AUTOMERGE_FAILED_TO_PARSE",
  YN0047: "AUTOMERGE_IMMUTABLE",
  YN0048: "AUTOMERGE_SUCCESS",
  YN0049: "AUTOMERGE_REQUIRED",
  YN0050: "DEPRECATED_CLI_SETTINGS",
  YN0059: "INVALID_RANGE_PEER_DEPENDENCY",
  YN0060: "INCOMPATIBLE_PEER_DEPENDENCY",
  YN0061: "DEPRECATED_PACKAGE",
  YN0062: "INCOMPATIBLE_OS",
  YN0063: "INCOMPATIBLE_CPU",
  YN0068: "UNUSED_PACKAGE_EXTENSION",
  YN0069: "REDUNDANT_PACKAGE_EXTENSION",
  YN0071: "NM_CANT_INSTALL_EXTERNAL_SOFT_LINK",
  YN0072: "NM_PRESERVE_SYMLINKS_REQUIRED",
  YN0074: "NM_HARDLINKS_MODE_DOWNGRADED",
  YN0075: "PROLOG_INSTANTIATION_ERROR",
  YN0076: "INCOMPATIBLE_ARCHITECTURE",
  YN0077: "GHOST_ARCHITECTURE"
};
var Yarn2Proxy = class extends JsPackageManager {
  constructor() {
    super(...arguments);
    this.type = "yarn2";
  }
  getInstallArgs() {
    if (!this.installArgs) {
      this.installArgs = [];
    }
    return this.installArgs;
  }
  async initPackageJson() {
    await this.executeCommand({ command: "yarn", args: ["init"] });
  }
  getRunStorybookCommand() {
    return "yarn storybook";
  }
  getRunCommand(command) {
    return `yarn ${command}`;
  }
  runPackageCommandSync(command, args, cwd, stdio) {
    return this.executeCommandSync({ command: "yarn", args: [command, ...args], cwd, stdio });
  }
  async runPackageCommand(command, args, cwd) {
    return this.executeCommand({ command: "yarn", args: [command, ...args], cwd });
  }
  async findInstallations(pattern) {
    const commandResult = await this.executeCommand({
      command: "yarn",
      args: [
        "info",
        "--name-only",
        "--recursive",
        pattern.map((p) => `"${p}"`).join(" "),
        `"${pattern}"`
      ]
    });
    try {
      return this.mapDependencies(commandResult);
    } catch (e) {
      return void 0;
    }
  }
  async getPackageJSON(packageName, basePath = this.cwd) {
    const pnpapiPath = sync$1([".pnp.js", ".pnp.cjs"], { cwd: basePath });
    if (pnpapiPath) {
      try {
        const pnpApi = __require(pnpapiPath);
        const resolvedPath = await pnpApi.resolveToUnqualified(packageName, basePath, {
          considerBuiltins: false
        });
        const pkgLocator = pnpApi.findPackageLocator(resolvedPath);
        const pkg = pnpApi.getPackageInformation(pkgLocator);
        const zipOpenFs = new ZipOpenFS({
          libzip: getLibzipSync()
        });
        const virtualFs = new VirtualFS({ baseFs: zipOpenFs });
        const crossFs = new PosixFS(virtualFs);
        const virtualPath = path2.join(pkg.packageLocation, "package.json");
        return crossFs.readJsonSync(virtualPath);
      } catch (error) {
        if (error.code !== "MODULE_NOT_FOUND") {
          console.error("Error while fetching package version in Yarn PnP mode:", error);
        }
        return null;
      }
    }
    const packageJsonPath = await sync$1(
      (dir) => {
        const possiblePath = path2.join(dir, "node_modules", packageName, "package.json");
        return existsSync(possiblePath) ? possiblePath : void 0;
      },
      { cwd: basePath }
    );
    if (!packageJsonPath) {
      return null;
    }
    const packageJson = JSON.parse(readFileSync$1(packageJsonPath, "utf-8"));
    return packageJson;
  }
  async getPackageVersion(packageName, basePath = this.cwd) {
    const packageJSON = await this.getPackageJSON(packageName, basePath);
    return packageJSON ? semver.coerce(packageJSON.version)?.version ?? null : null;
  }
  getResolutions(packageJson, versions) {
    return {
      resolutions: {
        ...packageJson.resolutions,
        ...versions
      }
    };
  }
  async runInstall() {
    await this.executeCommand({
      command: "yarn",
      args: ["install", ...this.getInstallArgs()],
      stdio: "inherit"
    });
  }
  async runAddDeps(dependencies, installAsDevDependencies) {
    let args = [...dependencies];
    if (installAsDevDependencies) {
      args = ["-D", ...args];
    }
    const { logStream, readLogFile, moveLogFile, removeLogFile } = await createLogStream();
    try {
      await this.executeCommand({
        command: "yarn",
        args: ["add", ...this.getInstallArgs(), ...args],
        stdio: ["ignore", logStream, logStream]
      });
    } catch (err) {
      const stdout = await readLogFile();
      const errorMessage = this.parseErrorFromLogs(stdout);
      await moveLogFile();
      throw new Error(
        dedent`${errorMessage}
        
        Please check the logfile generated at ./storybook.log for troubleshooting and try again.`
      );
    }
    await removeLogFile();
  }
  async runRemoveDeps(dependencies) {
    const args = [...dependencies];
    await this.executeCommand({
      command: "yarn",
      args: ["remove", ...this.getInstallArgs(), ...args],
      stdio: "inherit"
    });
  }
  async runGetVersions(packageName, fetchAllVersions) {
    const field = fetchAllVersions ? "versions" : "version";
    const args = ["--fields", field, "--json"];
    const commandResult = await this.executeCommand({
      command: "yarn",
      args: ["npm", "info", packageName, ...args]
    });
    try {
      const parsedOutput = JSON.parse(commandResult);
      return parsedOutput[field];
    } catch (e) {
      throw new Error(`Unable to find versions of ${packageName} using yarn 2`);
    }
  }
  mapDependencies(input) {
    const lines = input.split("\n");
    const acc = {};
    const existingVersions = {};
    const duplicatedDependencies = {};
    lines.forEach((packageName) => {
      if (!packageName || !packageName.includes("storybook")) {
        return;
      }
      const { name, value } = parsePackageData(packageName.replaceAll(`"`, ""));
      if (!existingVersions[name]?.includes(value.version)) {
        if (acc[name]) {
          acc[name].push(value);
        } else {
          acc[name] = [value];
        }
        existingVersions[name] = [...existingVersions[name] || [], value.version];
        if (existingVersions[name].length > 1) {
          duplicatedDependencies[name] = existingVersions[name];
        }
      }
    });
    return {
      dependencies: acc,
      duplicatedDependencies,
      infoCommand: "yarn why"
    };
  }
  parseErrorFromLogs(logs) {
    let finalMessage = "YARN2 error";
    const match = logs.match(YARN2_ERROR_REGEX);
    if (match) {
      const errorCode = match[1];
      if (errorCode) {
        finalMessage = `${finalMessage} ${errorCode}`;
      }
      const errorType = YARN2_ERROR_CODES[errorCode];
      if (errorType) {
        finalMessage = `${finalMessage} - ${errorType}`;
      }
      const errorMessage = match[2];
      if (errorMessage) {
        finalMessage = `${finalMessage}: ${errorMessage}`;
      }
    }
    return finalMessage.trim();
  }
};
var YARN1_ERROR_REGEX = /^error\s(.*)$/gm;
var Yarn1Proxy = class extends JsPackageManager {
  constructor() {
    super(...arguments);
    this.type = "yarn1";
  }
  getInstallArgs() {
    if (!this.installArgs) {
      this.installArgs = ["--ignore-workspace-root-check"];
    }
    return this.installArgs;
  }
  async initPackageJson() {
    await this.executeCommand({ command: "yarn", args: ["init", "-y"] });
  }
  getRunStorybookCommand() {
    return "yarn storybook";
  }
  getRunCommand(command) {
    return `yarn ${command}`;
  }
  runPackageCommandSync(command, args, cwd, stdio) {
    return this.executeCommandSync({ command: `yarn`, args: [command, ...args], cwd, stdio });
  }
  async runPackageCommand(command, args, cwd) {
    return this.executeCommand({ command: `yarn`, args: [command, ...args], cwd });
  }
  async getPackageJSON(packageName, basePath = this.cwd) {
    const packageJsonPath = await sync$1(
      (dir) => {
        const possiblePath = path2.join(dir, "node_modules", packageName, "package.json");
        return existsSync(possiblePath) ? possiblePath : void 0;
      },
      { cwd: basePath }
    );
    if (!packageJsonPath) {
      return null;
    }
    return JSON.parse(readFileSync$1(packageJsonPath, "utf-8"));
  }
  async getPackageVersion(packageName, basePath = this.cwd) {
    const packageJson = await this.getPackageJSON(packageName, basePath);
    return packageJson ? semver.coerce(packageJson.version)?.version ?? null : null;
  }
  async findInstallations(pattern) {
    const commandResult = await this.executeCommand({
      command: "yarn",
      args: ["list", "--pattern", pattern.map((p) => `"${p}"`).join(" "), "--recursive", "--json"]
    });
    try {
      const parsedOutput = JSON.parse(commandResult);
      return this.mapDependencies(parsedOutput);
    } catch (e) {
      return void 0;
    }
  }
  getResolutions(packageJson, versions) {
    return {
      resolutions: {
        ...packageJson.resolutions,
        ...versions
      }
    };
  }
  async runInstall() {
    await this.executeCommand({
      command: "yarn",
      args: ["install", ...this.getInstallArgs()],
      stdio: "inherit"
    });
  }
  async runAddDeps(dependencies, installAsDevDependencies) {
    let args = [...dependencies];
    if (installAsDevDependencies) {
      args = ["-D", ...args];
    }
    const { logStream, readLogFile, moveLogFile, removeLogFile } = await createLogStream();
    try {
      await this.executeCommand({
        command: "yarn",
        args: ["add", ...this.getInstallArgs(), ...args],
        stdio: ["ignore", logStream, logStream]
      });
    } catch (err) {
      const stdout = await readLogFile();
      const errorMessage = this.parseErrorFromLogs(stdout);
      await moveLogFile();
      throw new Error(
        dedent`${errorMessage}
        
        Please check the logfile generated at ./storybook.log for troubleshooting and try again.`
      );
    }
    await removeLogFile();
  }
  async runRemoveDeps(dependencies) {
    const args = [...dependencies];
    await this.executeCommand({
      command: "yarn",
      args: ["remove", ...this.getInstallArgs(), ...args],
      stdio: "inherit"
    });
  }
  async runGetVersions(packageName, fetchAllVersions) {
    const args = [fetchAllVersions ? "versions" : "version", "--json"];
    const commandResult = await this.executeCommand({
      command: "yarn",
      args: ["info", packageName, ...args]
    });
    try {
      const parsedOutput = JSON.parse(commandResult);
      if (parsedOutput.type === "inspect") {
        return parsedOutput.data;
      }
      throw new Error(`Unable to find versions of ${packageName} using yarn`);
    } catch (e) {
      throw new Error(`Unable to find versions of ${packageName} using yarn`);
    }
  }
  mapDependencies(input) {
    if (input.type === "tree") {
      const { trees } = input.data;
      const acc = {};
      const existingVersions = {};
      const duplicatedDependencies = {};
      const recurse = (tree) => {
        const { children } = tree;
        const { name, value } = parsePackageData(tree.name);
        if (!name || !name.includes("storybook"))
          return;
        if (!existingVersions[name]?.includes(value.version)) {
          if (acc[name]) {
            acc[name].push(value);
          } else {
            acc[name] = [value];
          }
          existingVersions[name] = [...existingVersions[name] || [], value.version];
          if (existingVersions[name].length > 1) {
            duplicatedDependencies[name] = existingVersions[name];
          }
        }
        children.forEach(recurse);
      };
      trees.forEach(recurse);
      return {
        dependencies: acc,
        duplicatedDependencies,
        infoCommand: "yarn why"
      };
    }
    throw new Error("Something went wrong while parsing yarn output");
  }
  parseErrorFromLogs(logs) {
    let finalMessage = "YARN1 error";
    const match = logs.match(YARN1_ERROR_REGEX);
    if (match) {
      const errorMessage = match[0]?.replace(/^error\s(.*)$/, "$1");
      if (errorMessage) {
        finalMessage = `${finalMessage}: ${errorMessage}`;
      }
    }
    return finalMessage.trim();
  }
};

// src/js-package-manager/JsPackageManagerFactory.ts
var NPM_LOCKFILE = "package-lock.json";
var PNPM_LOCKFILE = "pnpm-lock.yaml";
var YARN_LOCKFILE = "yarn.lock";
var JsPackageManagerFactory = class {
  static getPackageManager({ force } = {}, cwd) {
    if (force === "npm") {
      return new NPMProxy({ cwd });
    }
    if (force === "pnpm") {
      return new PNPMProxy({ cwd });
    }
    if (force === "yarn1") {
      return new Yarn1Proxy({ cwd });
    }
    if (force === "yarn2") {
      return new Yarn2Proxy({ cwd });
    }
    const yarnVersion = getYarnVersion(cwd);
    const closestLockfilePath = sync$1([YARN_LOCKFILE, PNPM_LOCKFILE, NPM_LOCKFILE], {
      cwd
    });
    const closestLockfile = closestLockfilePath && path2.basename(closestLockfilePath);
    const hasNPMCommand = hasNPM(cwd);
    const hasPNPMCommand = hasPNPM(cwd);
    if (yarnVersion && (closestLockfile === YARN_LOCKFILE || !hasNPMCommand && !hasPNPMCommand)) {
      return yarnVersion === 1 ? new Yarn1Proxy({ cwd }) : new Yarn2Proxy({ cwd });
    }
    if (hasPNPMCommand && closestLockfile === PNPM_LOCKFILE) {
      return new PNPMProxy({ cwd });
    }
    if (hasNPMCommand) {
      return new NPMProxy({ cwd });
    }
    throw new Error("Unable to find a usable package manager within NPM, PNPM, Yarn and Yarn 2");
  }
};
function hasNPM(cwd) {
  const npmVersionCommand = sync$2("npm", ["--version"], { cwd, shell: true });
  return npmVersionCommand.status === 0;
}
function hasPNPM(cwd) {
  const pnpmVersionCommand = sync$2("pnpm", ["--version"], { cwd, shell: true });
  return pnpmVersionCommand.status === 0;
}
function getYarnVersion(cwd) {
  const yarnVersionCommand = sync$2("yarn", ["--version"], { cwd, shell: true });
  if (yarnVersionCommand.status !== 0) {
    return void 0;
  }
  const yarnVersion = yarnVersionCommand.output.toString().replace(/,/g, "").replace(/"/g, "");
  return /^1\.+/.test(yarnVersion) ? 1 : 2;
}

export { HandledError, JsPackageManager, JsPackageManagerFactory, __commonJS, __require, __toESM, codeLog, commandLog, copyTemplate, copyTemplateFiles, createLogStream, externalFrameworks, getBabelDependencies, getCliDir, getEnvConfig, getPackageDetails, getStorybookVersion, getStorybookVersionSpecifier, installableProjectTypes, isNxProject, paddedLog, parseList, supportedTemplates, unsupportedTemplate, useNpmWarning, versions_default };
